/* tslint:disable */
/* eslint-disable */
/**
 * OpenAPI definition
 * No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)
 *
 * The version of the OpenAPI document: v0
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import {exists, mapValues} from '../runtime';
import {
  PartyAccountDto,
  PartyAccountDtoFromJSON,
  PartyAccountDtoFromJSONTyped,
  PartyAccountDtoToJSON,
} from './PartyAccountDto';
import {
  PartyDto,
  PartyDtoFromJSON,
  PartyDtoFromJSONTyped,
  PartyDtoToJSON,
} from './PartyDto';

/**
 *
 * @export
 * @interface ReferenceDataDto
 */
export interface ReferenceDataDto {
  /**
   *
   * @type {string}
   * @memberof ReferenceDataDto
   */
  bic: string;
  /**
   *
   * @type {Array<string>}
   * @memberof ReferenceDataDto
   */
  statuses: Array<string>;
  /**
   *
   * @type {Array<string>}
   * @memberof ReferenceDataDto
   */
  currencies: Array<string>;
  /**
   *
   * @type {Array<PartyDto>}
   * @memberof ReferenceDataDto
   */
  parties: Array<PartyDto>;
  /**
   *
   * @type {Array<PartyAccountDto>}
   * @memberof ReferenceDataDto
   */
  accounts: Array<PartyAccountDto>;
}

export function ReferenceDataDtoFromJSON(json: any): ReferenceDataDto {
  return ReferenceDataDtoFromJSONTyped(json, false);
}

export function ReferenceDataDtoFromJSONTyped(
  json: any,
  ignoreDiscriminator: boolean
): ReferenceDataDto {
  if (json === undefined || json === null) {
    return json;
  }
  return {
    bic: json['bic'],
    statuses: json['statuses'],
    currencies: json['currencies'],
    parties: (json['parties'] as Array<any>).map(PartyDtoFromJSON),
    accounts: (json['accounts'] as Array<any>).map(PartyAccountDtoFromJSON),
  };
}

export function ReferenceDataDtoToJSON(value?: ReferenceDataDto | null): any {
  if (value === undefined) {
    return undefined;
  }
  if (value === null) {
    return null;
  }
  return {
    bic: value.bic,
    statuses: value.statuses,
    currencies: value.currencies,
    parties: (value.parties as Array<any>).map(PartyDtoToJSON),
    accounts: (value.accounts as Array<any>).map(PartyAccountDtoToJSON),
  };
}
